@setlocal DisableDelayedExpansion
@echo off
:: Change to 1 to install DLL hook for ESU-supported editions
set ForceHook=0

set "SysPath=%SystemRoot%\System32"
if exist "%SystemRoot%\Sysnative\reg.exe" (set "SysPath=%SystemRoot%\Sysnative")
set "Path=%SysPath%;%SystemRoot%;%SysPath%\Wbem;%SysPath%\WindowsPowerShell\v1.0\"
set "_err===== ERROR ===="
set "xOS=64"
if /i %PROCESSOR_ARCHITECTURE%==x86 (if not defined PROCESSOR_ARCHITEW6432 (
  set "xOS=32"
  )
)
set "IFEO=HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Image File Execution Options"

reg query HKU\S-1-5-19 1>nul 2>nul || goto :E_Admin
for /f "tokens=6 delims=[]. " %%# in ('ver') do if not %%#==7601 goto :E_Win

set "_work=%~dp0bin\"
setlocal EnableDelayedExpansion
pushd "!_work!"
if not exist "superUser%xOS%.exe" set _file=superUser%xOS%.exe&goto :E_DLL

for /f "skip=2 tokens=2*" %%a in ('reg query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v ProductName 2^>nul') do set "_name=%%b"
for /f "tokens=2 delims==" %%# in ('"wmic OS Get OperatingSystemSKU /value" 2^>nul') do if not errorlevel 1 set _sku=%%#
if "%_sku%"=="65" (
reg query HKLM\SOFTWARE\Microsoft\POSReady /v Version 2>nul | find "7.0" 1>nul && set "_name=Windows Embedded POSReady 7"
)

echo.
echo ## OS Info ##
echo.
echo Name: %_name%
if defined _sku echo SKU : %_sku%
echo.

if "%ForceHook%"=="1" goto :Hook
if not defined _sku goto :Hook

set _esu=0
set "_skus=4 27 70 1 28 71 48 49 69 7 8 10 12 13 14 36 37 38 39 40 41"
for %%# in (%_skus%) do if %_sku%==%%# set _esu=1
if %_esu%==1 goto :SLC

:Hook
if not exist "BypassESU%xOS%.dll" set _file=BypassESU%xOS%.dll&goto :E_DLL
echo ## Installing hook BypassESU.dll ##
call :StopService wuauserv 1>nul 2>nul
call :StopService TrustedInstaller 1>nul 2>nul
echo.
echo Adding File . . .
echo %SystemRoot%\System32\BypassESU.dll
if exist "%SysPath%\kurwica*.dll" del /f /q %SysPath%\kurwica*.dll
if exist "%SysPath%\gesu.dll" del /f /q %SysPath%\gesu.dll
if exist "%SysPath%\esuslc.dll" del /f /q %SysPath%\esuslc.dll
if exist "%SystemRoot%\servicing\slc.dll" 1>nul 2>nul superUser%xOS%.exe /w /c cmd.exe /c del /f /q %SystemRoot%\servicing\slc.dll
copy /y BypassESU%xOS%.dll %SysPath%\BypassESU.dll 1>nul 2>nul
echo.
echo Adding Registry Key . . .
echo [%IFEO%
echo \TrustedInstaller.exe]
reg delete "%IFEO%\TrustedInstaller.exe" /f 1>nul 2>nul
reg add "%IFEO%\TrustedInstaller.exe" /f /v Debugger /t REG_SZ /d "rundll32.exe BypassESU.dll,PatcherMain" 1>nul 2>nul
echo.
echo Done
goto :TheEnd

:SLC
if not exist "slc%xOS%.dll" set _file=slc%xOS%.dll&goto :E_DLL
echo ## Installing custom slc.dll ##
call :StopService wuauserv 1>nul 2>nul
call :StopService TrustedInstaller 1>nul 2>nul
echo.
echo Adding File . . .
echo %SystemRoot%\servicing\slc.dll
if exist "%SysPath%\kurwica*.dll" del /f /q "%SysPath%\kurwica*.dll" 
if exist "%SysPath%\gesu.dll" del /f /q %SysPath%\gesu.dll
if exist "%SysPath%\BypassESU.dll" del /f /q %SysPath%\BypassESU.dll
reg delete "%IFEO%\TrustedInstaller.exe" /f 1>nul 2>nul
net start TrustedInstaller 1>nul 2>nul
1>nul 2>nul superUser%xOS%.exe /w /c cmd.exe /c copy /y slc%xOS%.dll %SystemRoot%\servicing\slc.dll
if not exist "%SystemRoot%\servicing\slc.dll" (
echo %_err%
echo Failed.
echo.
goto :Hook
)
echo.
echo Duplicating original slc.dll to esuslc.dll . . .
copy /y %SysPath%\slc.dll %SysPath%\esuslc.dll 1>nul 2>nul
echo.
echo Done
goto :TheEnd

:StopService
wmic service %1 call StopService
sc query %1 | find /i "STOPPED" || net stop %1 /y
sc query %1 | find /i "STOPPED" || sc stop %1
goto :eof

:E_Admin
echo %_err%
echo This script requires administrator privileges.
goto :TheEnd

:E_Win
echo %_err%
echo This project requires Windows 7 SP1.
goto :TheEnd

:E_DLL
echo %_err%
echo Required file bin\%_file% is missing.

:TheEnd
echo.
echo Press any key to exit.
pause >nul
goto :eof
